import clr

clr.AddReference('Blaney.Radar')
clr.AddReference('CircleControl')
clr.AddReference('System.Drawing')
clr.AddReference('System.Windows.Forms')
clr.AddReference('Microsoft.Xna.Framework')
clr.AddReference('PolyMonControls')
clr.AddReference('RadarControl')

import GAW
#import Microsoft.Xna.Framework
from Microsoft.Xna.Framework import *
#import Microsoft.Xna.Framework.Input
from Microsoft.Xna.Framework.Input import *
from PolyMonControls import *
from RadarControl import *
import System.Drawing
from System.IO.Ports import *
from System.Windows.Forms import *
from Blaney import *

class Form1(Form):
	#currentState = None
	oldState = None
	serialPort1 = None
	def InitializeComponent(self):
		# build menu items
		self.menuStrip1 = MenuStrip()
		self.fileToolStripMenuItem = ToolStripMenuItem()
		self.fileToolStripMenuItem.Text = "&File"
		self.toolStripSeparator1 = ToolStripSeparator()
		self.exitToolStripMenuItem = ToolStripMenuItem()
		self.exitToolStripMenuItem.Text = "E&xit"
		self.exitToolStripMenuItem.Click += self.exitToolStripMenuItem_Click
		self.fileToolStripMenuItem.DropDownItems.Add(self.toolStripSeparator1)
		self.fileToolStripMenuItem.DropDownItems.Add(self.exitToolStripMenuItem)
		self.menuStrip1.Items.Add(self.fileToolStripMenuItem)
		self.toolStripMenuItem1 = ToolStripMenuItem()
		self.toolStripMenuItem1.Text = "&Tools"
		self.serialPortToolStripMenuItem = ToolStripMenuItem()
		self.serialPortToolStripMenuItem.Text = "&Serial Port"
		self.serialPortToolStripMenuItem.DropDownOpening += self.serialPortToolStripMenuItem_Click
		self.serialPortComboBox = ToolStripComboBox()
		self.serialPortComboBox.Text = "Select a Serial Port"
		self.serialPortToolStripMenuItem.DropDownItems.Add(self.serialPortComboBox)
		self.connectToolStripMenuItem = ToolStripMenuItem()
		self.connectToolStripMenuItem.Text = "Connect"
		self.connectToolStripMenuItem.Enabled = False
		self.disconnectToolStripMenuItem = ToolStripMenuItem()
		self.disconnectToolStripMenuItem.Text = "Disconnect"
		self.disconnectToolStripMenuItem.Enabled = False
		self.toolStripMenuItem1.DropDownItems.Add(self.serialPortToolStripMenuItem)
		self.toolStripMenuItem1.DropDownItems.Add(self.connectToolStripMenuItem)
		self.toolStripMenuItem1.DropDownItems.Add(self.disconnectToolStripMenuItem)
		self.menuStrip1.Items.Add(self.toolStripMenuItem1)
		# end build menu items
		# build main panel table layout
		self.tableLayoutPanel1 = TableLayoutPanel()
		self.tableLayoutPanel1.ColumnCount = 5
		self.tableLayoutPanel1.RowCount = 3
		self.tableLayoutPanel1.Location = System.Drawing.Point(0, 27)
		self.tableLayoutPanel1.Size = System.Drawing.Size(1024, 400)
		# groupBox1
		self.groupBox1 = GroupBox()
		self.groupBox1.Location = System.Drawing.Point(3, 3)
		self.groupBox1.Size = System.Drawing.Size(168, 184)
		self.groupBox1.Text = "Motor 1"
		self.motor1Gauge = RadialGauge()
		self.motor1Gauge.Location = System.Drawing.Point(6, 19)
		self.motor1Gauge.Size = System.Drawing.Size(150, 150)
		self.groupBox1.Controls.Add(self.motor1Gauge)
		self.tableLayoutPanel1.Controls.Add(self.groupBox1, 0, 0)
		# groupBox2
		self.groupBox2 = GroupBox()
		self.groupBox2.Location = System.Drawing.Point(3, 3)
		self.groupBox2.Size = System.Drawing.Size(168, 184)
		self.groupBox2.Text = "Motor 2"
		self.motor2Gauge = RadialGauge()
		self.motor2Gauge.Location = System.Drawing.Point(6, 19)
		self.motor2Gauge.Size = System.Drawing.Size(150, 150)
		self.groupBox2.Controls.Add(self.motor2Gauge)
		self.tableLayoutPanel1.Controls.Add(self.groupBox2, 1, 0)
		# groupBox3
		self.groupBox3 = GroupBox()
		self.groupBox3.Size = System.Drawing.Size(168, 184)
		self.groupBox3.Text = "Sonar Rangefinder"
		self.radarControl1 = RadarControl()
		self.radarControl1.Location = System.Drawing.Point(6, 19)
		self.radarControl1.Size = System.Drawing.Size(150, 150)
		self.radarItem = TriangleRadarItem(3, 8, 0, 5)
		#self.radarItem.Azimuth = 4
		#self.radarItem.Elevation = 100
		self.radarControl1.Radar.AddItem(self.radarItem)
		self.groupBox3.Controls.Add(self.radarControl1)
		self.tableLayoutPanel1.Controls.Add(self.groupBox3, 2, 0)
		# groupBox4
		self.groupBox4 = GroupBox()
		self.groupBox4.Size = System.Drawing.Size(168, 184)
		self.groupBox4.Text = "Motor Fuel"
		self.cylinderGauge1 = CylinderGauge()
		self.cylinderGauge1.FillPercentage = 100
		self.cylinderGauge1.Location = System.Drawing.Point(44, 19)
		self.cylinderGauge1.Size = System.Drawing.Size(75, 150)
		self.groupBox4.Controls.Add(self.cylinderGauge1)
		self.tableLayoutPanel1.Controls.Add(self.groupBox4, 3, 0)
		# groupBox5 - Servo 1
		self.groupBox5 = GroupBox()
		self.groupBox5.Size = System.Drawing.Size(168, 184)
		self.groupBox5.Text = "Servo 1"
		self.cc1 = GAW.CircleControl()
		self.cc1.AngleMax = 360
		self.cc1.AngleMin = 0
		self.cc1.AngleWraps = True
		self.cc1.MajorTickColor = System.Drawing.SystemColors.Control
		self.cc1.MajorTicks = 10;
		self.cc1.MajorTickSize = 0.45
		self.cc1.MajorTickStart = 0.4
		self.cc1.MajorTickThickness = 0.45
		self.cc1.MinorTickColor = System.Drawing.Color.Black
		self.cc1.MinorTickSize = 0.25
		self.cc1.MinorTickStart = 0.5
		self.cc1.MinorTickThickness = 0.45
		self.cc1.PrimaryMarkerAngle = 0
		self.cc1.PrimaryMarkerBorderColor = System.Drawing.Color.Black
		self.cc1.PrimaryMarkerBorderSize = 2
		self.cc1.Location = System.Drawing.Point(6, 19)
		self.cc1.Size = System.Drawing.Size(150, 150)
		self.cc1.Rings.Add(GAW.CircleControl.Ring(0.6, System.Drawing.Color.Beige, System.Drawing.Color.Black, 2.0))
		self.ccFont = System.Drawing.Font("Arial", 8.0)
		self.cc1.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "90", 0.8, 90.0))
		self.cc1.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "270", 0.8, 270.0))
		self.cc1.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "0", 0.8, 0.0))
		self.cc1.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "180", 0.8, 180.0))
		self.groupBox5.Controls.Add(self.cc1)
		self.tableLayoutPanel1.Controls.Add(self.groupBox5, 0, 1)
		# groupBox6 - Servo2
		self.groupBox6 = GroupBox()
		self.groupBox6.Size = System.Drawing.Size(168, 184)
		self.groupBox6.Text = "Servo 2"
		self.cc2 = GAW.CircleControl()
		self.cc2.AngleMax = 360
		self.cc2.AngleMin = 0
		self.cc2.AngleWraps = True
		self.cc2.MajorTickColor = System.Drawing.SystemColors.Control
		self.cc2.MajorTicks = 10;
		self.cc2.MajorTickSize = 0.45
		self.cc2.MajorTickStart = 0.4
		self.cc2.MajorTickThickness = 0.45
		self.cc2.MinorTickColor = System.Drawing.Color.Black;
		self.cc2.MinorTickSize = 0.25
		self.cc2.MinorTickStart = 0.5
		self.cc2.MinorTickThickness = 0.45
		self.cc2.PrimaryMarkerAngle = 0;
		self.cc2.PrimaryMarkerBorderColor = System.Drawing.Color.Black;
		self.cc2.PrimaryMarkerBorderSize = 2;
		self.cc2.Location = System.Drawing.Point(6, 19)
		self.cc2.Size = System.Drawing.Size(150, 150)
		self.cc2.Rings.Add(GAW.CircleControl.Ring(0.6, System.Drawing.Color.Beige, System.Drawing.Color.Black, 2.0))
		self.cc2.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "90", 0.8, 90.0))
		self.cc2.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "270", 0.8, 270.0))
		self.cc2.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "0", 0.8, 0.0))
		self.cc2.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "180", 0.8, 180.0))
		self.groupBox6.Controls.Add(self.cc2)
		self.tableLayoutPanel1.Controls.Add(self.groupBox6, 1, 1)
		# groupBox7 - Controller
		self.groupBox7 = GroupBox()
		self.groupBox7.Size = System.Drawing.Size(168, 184)
		self.groupBox7.Text = "XBox Controller"
		self.rightYLabel = Label()
		self.rightYLabel.Location = System.Drawing.Point(6, 120)
		self.rightYLabel.Size = System.Drawing.Size(100, 13)
		self.rightYLabel.Text = "Right Y:"
		self.groupBox7.Controls.Add(self.rightYLabel)
		self.rightXLabel = Label()
		self.rightXLabel.Location = System.Drawing.Point(6, 90)
		self.rightXLabel.Size = System.Drawing.Size(100, 13)
		self.rightXLabel.Text = "Right X:"
		self.groupBox7.Controls.Add(self.rightXLabel)
		self.leftXLabel = Label()
		self.leftXLabel.Location = System.Drawing.Point(6, 30)
		self.leftXLabel.Size = System.Drawing.Size(100, 13)
		self.leftXLabel.Text = "Left X:"
		self.groupBox7.Controls.Add(self.leftXLabel)
		self.leftYLabel = Label()
		self.leftYLabel.Location = System.Drawing.Point(6, 60)
		self.leftYLabel.Size = System.Drawing.Size(100, 13)
		self.leftYLabel.Text = "Left Y:"
		self.groupBox7.Controls.Add(self.leftYLabel)
		self.POVLabel = Label()
		self.POVLabel.Location = System.Drawing.Point(6, 150)
		self.POVLabel.Size = System.Drawing.Size(100, 13)
		self.POVLabel.Text = "POV:"
		self.groupBox7.Controls.Add(self.POVLabel)
		self.tableLayoutPanel1.Controls.Add(self.groupBox7, 3, 1)
		# groupBox8 - Compass
		self.groupBox8 = GroupBox()
		self.groupBox8.Size = System.Drawing.Size(168, 184)
		self.groupBox8.Text = "HMC5883L Compass"
		self.cc3 = GAW.CircleControl()
		self.cc3.AngleMax = 360
		self.cc3.AngleMin = 0
		self.cc3.AngleWraps = True
		self.cc3.MajorTickColor = System.Drawing.SystemColors.Control
		self.cc3.MajorTicks = 10;
		self.cc3.MajorTickSize = 0.45
		self.cc3.MajorTickStart = 0.4
		self.cc3.MajorTickThickness = 0.45
		self.cc3.MinorTickColor = System.Drawing.Color.Black;
		self.cc3.MinorTickSize = 0.25
		self.cc3.MinorTickStart = 0.5
		self.cc3.MinorTickThickness = 0.45
		self.cc3.PrimaryMarkerAngle = 90;
		self.cc3.PrimaryMarkerBorderColor = System.Drawing.Color.Black;
		self.cc3.PrimaryMarkerBorderSize = 2;
		self.cc3.Location = System.Drawing.Point(6, 19)
		self.cc3.Size = System.Drawing.Size(150, 150)
		self.cc3.Rings.Add(GAW.CircleControl.Ring(0.6, System.Drawing.Color.Beige, System.Drawing.Color.Black, 2.0))
		self.ccFont = System.Drawing.Font("Arial", 8.0)
		self.cc3.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "N", 0.8, 90.0))
		self.cc3.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "S", 0.8, 270.0))
		self.cc3.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "E", 0.8, 0.0))
		self.cc3.TextItems.Add(GAW.CircleControl.TextItem(self.ccFont, System.Drawing.Color.Red, "W", 0.8, 180.0))
		self.groupBox8.Controls.Add(self.cc3)
		self.tableLayoutPanel1.Controls.Add(self.groupBox8, 2, 1)
		# groupBox9 - XBEE
		self.groupBox9 = GroupBox()
		self.groupBox9.Size = System.Drawing.Size(168, 184)
		self.groupBox9.Text = "XBEE"
		self.rssiGauge = BarGauge()
		self.rssiGauge.Location = System.Drawing.Point(6, 110)
		self.rssiGauge.Size = System.Drawing.Size(156, 55)
		self.groupBox9.Controls.Add(self.rssiGauge)
		self.lnkLight = StatusLight()
		self.lnkLight.Location = System.Drawing.Point(134, 81)
		self.lnkLight.Size = System.Drawing.Size(28, 23)
		self.groupBox9.Controls.Add(self.lnkLight)
		self.label1 = Label()
		self.label1.Location = System.Drawing.Point(111, 87)
		self.label1.Size = System.Drawing.Size(28, 13)
		self.label1.Text = "LNK"
		self.groupBox9.Controls.Add(self.label1)
		self.txLabel = Label()
		self.txLabel.Location = System.Drawing.Point(51, 87)
		self.txLabel.Size = System.Drawing.Size(21, 13)
		self.txLabel.Text = "TX"
		self.groupBox9.Controls.Add(self.txLabel)
		self.rxLabel = Label()
		self.rxLabel.Location = System.Drawing.Point(7, 87)
		self.rxLabel.Size = System.Drawing.Size(22, 13)
		self.rxLabel.Text = "RX"
		self.groupBox9.Controls.Add(self.rxLabel)
		self.txLight = StatusLight()
		self.txLight.Location = System.Drawing.Point(68, 81)
		self.txLight.Size = System.Drawing.Size(28, 23)
		self.groupBox9.Controls.Add(self.txLight)
		self.rxLight = StatusLight()
		self.rxLight.Location = System.Drawing.Point(26, 81)
		self.rxLight.Size = System.Drawing.Size(28, 23)
		self.groupBox9.Controls.Add(self.rxLight)
		self.pictureBox1 = PictureBox()
		self.pictureBox1.Image = System.Drawing.Bitmap("xbee-top-view-cropped.jpg")
		self.pictureBox1.Size = System.Drawing.Size(146, 62)
		self.pictureBox1.SizeMode = PictureBoxSizeMode.Zoom
		self.pictureBox1.Location = System.Drawing.Point(10, 16)
		self.groupBox9.Controls.Add(self.pictureBox1)
		self.tableLayoutPanel1.Controls.Add(self.groupBox9, 4, 0)
		# status strip
		self.statusStrip1 = StatusStrip()
		#self.statusStrip1.Location = System.Drawing.Point(0, 200)
		self.statusStrip1.Size = System.Drawing.Size(544, 22)
		self.toolStripStatusLabel1 = ToolStripStatusLabel()
		self.toolStripStatusLabel1.Size = System.Drawing.Size(185, 17)
		self.toolStripStatusLabel1.Text = "Current COM Port: None Selected"
		self.statusStrip1.Items.Add(self.toolStripStatusLabel1)
		self.connectionStatusLabel = ToolStripStatusLabel()
		self.connectionStatusLabel.Size = System.Drawing.Size(185, 17)
		self.connectionStatusLabel.Text = "Connection Status: Disconnected"
		self.statusStrip1.Items.Add(self.connectionStatusLabel)
		self.gamepadStatusLabel = ToolStripStatusLabel()
		self.gamepadStatusLabel.Size = System.Drawing.Size(185, 17)
		self.gamepadStatusLabel.Text = "Gamepad Status: Disconnected"
		self.statusStrip1.Items.Add(self.gamepadStatusLabel)
		# timers
		self.gamepadTimer = Timer()
		self.gamepadTimer.Interval = 70
		self.gamepadTimer.Tick += self.gamepadTimerTick
		self.gamepadTimer.Start()
		self.rssiTimer = Timer()
		self.rssiTimer.Interval = 15000
		self.rssiTimer.Tick += self.rssiTimerTick
		self.rssiTimer.Start()
		self.voltageTimer = Timer()
		self.voltageTimer.Interval = 13000
		self.voltageTimer.Tick += self.voltageTimerTick
		self.voltageTimer.Start()
		self.compassTimer = Timer()
		self.compassTimer.Interval = 500
		self.compassTimer.Tick += self.compassTimerTick
		self.compassTimer.Start()
		self.distanceTimer = Timer()
		self.distanceTimer.Interval = 500
		self.distanceTimer.Tick += self.distanceTimerTick
		self.distanceTimer.Start()
		
		# main form properties
		self.BackColor = System.Drawing.Color.Silver
		self.ClientSize = System.Drawing.Size(900, 500)
		self.Text = 'Propagator Console'
		
		#add the controls
		self.Controls.Add(self.statusStrip1)
		self.Controls.Add(self.menuStrip1)
		self.Controls.Add(self.tableLayoutPanel1)
		
		# other initializations
		if GamePad.GetState(PlayerIndex.One).IsConnected:
			self.gamepadStatusLabel.Text = "Gamepad Status: Connected"
			
		self.serialPortComboBox.SelectedIndexChanged += self.serialPortComboBox_SelectedIndexChanged
		
		self.serialPort1 = SerialPort()
		self.serialPort1.DataReceived += self.serialPort1_DataReceived
		
		self.connectToolStripMenuItem.Click += self.connectToolStripMenuItem_Click
		
		self.disconnectToolStripMenuItem.Click += self.disconnectToolStripMenuItem_Click
		
		self.pan = 1650 # this is center angle for the propbot
		self.tilt = 2300 # this is straight up tilt for the propbot

	def connectToolStripMenuItem_Click(self, sender, event_args):
		self.serialPort1.PortName = self.serialPortComboBox.SelectedItem.ToString()
		self.serialPort1.Open()
		self.connectToolStripMenuItem.Enabled = False
		self.disconnectToolStripMenuItem.Enabled = True
		self.connectionStatusLabel.Text = "Connection Status: Connected"
		self.lnkLight.Value = 0
	
	def disconnectToolStripMenuItem_Click(self, sender, event_args):
		self.serialPort1.Close()
		self.disconnectToolStripMenuItem.Enabled = False
		self.connectionStatusLabel.Text = "Connection Status: Disconnected"
		self.lnkLight.Value = -1
		self.toolStripStatusLabel1.Text = "Current COM Port: None"

	def exitToolStripMenuItem_Click(self, sender, event_args):
		Application.Exit()
		
	def gamepadTimerTick(self, sender, event_args):
		if GamePad.GetState(PlayerIndex.One).IsConnected:
			self.currentState = GamePad.GetState(PlayerIndex.One)
			if self.oldState is not None:
				oldLeftThumbStick = self.oldState.ThumbSticks.Left
				oldRightThumbStick = self.oldState.ThumbSticks.Right
			if self.currentState.Buttons.A == Input.ButtonState.Pressed:
				if self.motor1Gauge.Value > 0:
					self.motor1Gauge.Value -= 1
				if self.motor2Gauge.Value > 0:
					self.motor2Gauge.Value -= 1
			if self.currentState.Buttons.Y == Input.ButtonState.Pressed:
				if self.motor1Gauge.Value < 100:
					self.motor1Gauge.Value += 1
				if self.motor2Gauge.Value < 100:
					self.motor2Gauge.Value += 1
			if self.currentState.DPad.Left == Input.ButtonState.Pressed:
				self.POVLabel.Text = "POV: " + u"\u2190"
				if self.serialPort1.IsOpen:
					if self.pan > 1000: # 1000 is limit left on the panning, this is a guard
						self.pan -= 50
						markerAngle = self.cc1.PrimaryMarkerAngle
						markerAngle -= 10
						self.cc1.PrimaryMarkerAngle = markerAngle
						self.serialPort1.Write("p" + System.String(self.pan) + ",")
			elif self.currentState.DPad.Right == Input.ButtonState.Pressed:
				self.POVLabel.Text = "POV: " + u"\u2192"
				if self.serialPort1.IsOpen:
					if self.pan < 2300: # 2300 is limit right on the panning, this is a guard
						self.pan += 50
						markerAngle = self.cc1.PrimaryMarkerAngle
						markerAngle += 10
						self.cc1.PrimaryMarkerAngle = markerAngle
						self.serialPort1.Write("p" + System.String(self.pan) + ",")
			elif self.currentState.DPad.Up == Input.ButtonState.Pressed:
				self.POVLabel.Text = "POV: " + u"\u2191"
				if self.serialPort1.IsOpen:
					if self.tilt > 1700: #1700 is limit down on tilt, this is a guard
						self.tilt -= 50
						markerAngle = self.cc2.PrimaryMarkerAngle
						markerAngle -= 10
						self.cc2.PrimaryMarkerAngle = markerAngle
						self.serialPort1.Write("t" + System.String(self.tilt) + ",")
			elif self.currentState.DPad.Down == Input.ButtonState.Pressed:
				self.POVLabel.Text = "POV: " + u"\u2193"
				if self.serialPort1.IsOpen:
					if self.tilt < 2300: #2300 is limit up on tilt, this is a guard
						self.tilt += 50
						markerAngle = self.cc2.PrimaryMarkerAngle
						markerAngle += 10
						self.cc2.PrimaryMarkerAngle = markerAngle
						self.serialPort1.Write("t" + System.String(self.tilt) + ",")
			else:
				self.POVLabel.Text = "POV:"
			leftThumbStick = self.currentState.ThumbSticks.Left;
			rightThumbStick = self.currentState.ThumbSticks.Right;
			self.leftXLabel.Text = "Left X: " + System.String(leftThumbStick.X)
			self.leftYLabel.Text = "Left Y: " + System.String(leftThumbStick.Y)
			self.rightXLabel.Text = "Right X: " + System.String(rightThumbStick.X)
			self.rightYLabel.Text = "Right Y: " + System.String(rightThumbStick.Y)
			l_duty = 0
			r_duty = 0
			if self.serialPort1.IsOpen:
				if leftThumbStick.Y > 0:
					l_duty = ((self.motor1Gauge.Value / 100) * 40) + 60
				elif leftThumbStick.Y < 0:
					l_duty = (((self.motor1Gauge.Value / 100) * 40) + 60) * -1
				if rightThumbStick.Y > 0:
					r_duty = ((self.motor2Gauge.Value / 100) * 40) + 60
				elif rightThumbStick.Y < 0:
					r_duty = (((self.motor2Gauge.Value / 100) * 40) + 60) * -1
				if leftThumbStick.Y != oldLeftThumbStick.Y:
					if self.serialPort1.IsOpen:
						self.serialPort1.Write("l" + System.Convert.ToInt16(l_duty).ToString() + ",")
				if rightThumbStick.Y != oldRightThumbStick.Y:
					if self.serialPort1.IsOpen:
						self.serialPort1.Write("r" + System.Convert.ToInt16(r_duty).ToString() + ",")
			self.oldState = self.currentState
			
	def serialPortComboBox_SelectedIndexChanged(self, sender, event_args):
		self.toolStripStatusLabel1.Text = "Current COM Port: " + self.serialPortComboBox.SelectedItem.ToString()
		self.connectToolStripMenuItem.Enabled = True
	
	def serialPort1_DataReceived(self, sender, event_args):
		message = self.serialPort1.ReadLine()
		if ':' in message:
			tokens = message.split(':')
			msgType = tokens[0]
			value = tokens[1]
			if 'RSSI' in msgType:
				self.rssiGauge.Value = System.Int32.Parse(value)
			elif 'VOLTAGE' in msgType:
				voltage = System.Double.Parse(value)
				percentage = voltage / 5.25
				self.cylinderGauge1.FillPercentage = System.Convert.ToInt16(percentage * 100.0)
			elif 'COMPASS' in msgType:
				azimuth = System.Int32.Parse(value)
				self.cc3.PrimaryMarkerAngle = azimuth + 90 # add 90 to adjust for the widget layout
			elif 'DISTANCE' in msgType:
				cm = System.Double.Parse(value)
				percentage = (cm / 80.0) * 100.0
				#System.Console.WriteLine(cm)
				self.radarItem.Elevation = System.Convert.ToInt16(100.0 - percentage)
		else:
			System.Console.WriteLine(message)
	
	def serialPortToolStripMenuItem_Click(self, sender, event_args):
		self.serialPortComboBox.Items.Clear()
		serialPorts = SerialPort.GetPortNames()
		self.serialPortComboBox.Items.AddRange(serialPorts)
		
	def rssiTimerTick(self, sender, event_args):
		if self.serialPort1.IsOpen:
			self.serialPort1.Write("S") #RSSI
			
			
	def voltageTimerTick(self, sender, event_args):
		if self.serialPort1.IsOpen:
			self.serialPort1.Write("V") #Voltage
			
	def compassTimerTick(self, sender, event_args):
		if self.serialPort1.IsOpen:
			self.serialPort1.Write("C") #Compass
			
	def distanceTimerTick(self, sender, event_args):
		if self.serialPort1.IsOpen:
			self.serialPort1.Write("D") #GP2D12 sensor


